//
//  DohTools.m
//  Doh
//
//  Created by Hugues Devaux (hdex@free.fr) on 18/06/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//
// Classe permettant la détection d'une addresse IP, si une mise à jour du DynDNS est requise et la mise à jour du serveur DynDNS
/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
*/
#import "DohTools.h"


@implementation DohTools

- (id) init {
	self = [super init];

	return self;
}

//Accesseurs de la variable needRegistration
- (void)setNeedRegistration:(BOOL)nreg;
{
needRegistration = nreg;
}

- (BOOL)getNeedRegistration;
{
return needRegistration;
}

- (NSString *)webIpDetection:(NSString *)oldIP;
{
// Using external IP detection via PHP script hosted on hdex.free.fr

NSMutableString *ipDetectionWebsite = [NSMutableString stringWithCapacity:100];
   
[ipDetectionWebsite setString:@"http://hdex.free.fr/ip.php"];
   
// append a "?2345" where 2345 is actually a random number; forces
// proxy servers to fetch a fresh version of the file.
[ipDetectionWebsite appendString:@"?"];
[ipDetectionWebsite appendString:[[NSNumber numberWithLong:random()] stringValue]];

NSString *newIP=[NSString stringWithContentsOfURL: [NSURL URLWithString:ipDetectionWebsite]];

if ([newIP isEqualToString:@""])
				{
				NSLog(@"OVH@Home : Can't detect IP - Internet connection to be checked");
				[self setNeedRegistration:FALSE];
				return NSLocalizedString(@"Unknown", nil);
				}

if (![oldIP isEqualToString:newIP])
				{
				NSLog(@"OVH@Home : New IP detected - Registration needed");
				NSLog(@"OVH@Home : Old IP = @%@ - New IP = @%@", oldIP, newIP);
				[self setNeedRegistration:TRUE];
				
				}
			else {
				NSLog(@"OVH@Home :  IP unchanged - Checking Registration date");
				// Check date and force registration : IP unchanged but last registration date >= 28 days
				NSDate *startDate = [[NSUserDefaults standardUserDefaults] valueForKey:@"lastRegistration"];
				NSDate *endDate = [NSDate date];
				
				NSCalendar *gregorian = [[NSCalendar alloc] initWithCalendarIdentifier:NSGregorianCalendar];
				NSDateComponents *components = [gregorian components:NSDayCalendarUnit fromDate:startDate toDate:endDate options:0];

				int dayInterval = [components day];
				if ( dayInterval>=28) {
									[self setNeedRegistration:TRUE];
									}
				else {
					[self setNeedRegistration:FALSE];
					}

				
			}


return newIP;

}

- (NSString *)dyndnsRegistration:(NSString *)user :(NSString *)pwd :(NSString *)site :(NSString *)ipAdress;
{
NSMutableString *ovhDynDNS = [NSMutableString stringWithCapacity:300];

[ovhDynDNS setString:[[NSString alloc] initWithFormat:@"http://%@:%@@www.ovh.com/nic/update?system=dyndns&hostname=%@&myip=%@&wildcard=ON&backmx=NO",user,pwd,site,ipAdress]];

// Using curl to update DynDNS record
NSTask *curltask=[[NSTask alloc] init];

[curltask setLaunchPath:@"/usr/bin/curl"];
[curltask setArguments:[NSArray arrayWithObjects:@"-s",ovhDynDNS,nil]];

NSPipe *pipe=[[NSPipe alloc] init];
NSFileHandle *handle;
[curltask setStandardOutput:pipe];
handle=[pipe fileHandleForReading];

[curltask launch];

// Get result code and convert as a string
NSString *resultCodeFromDynDNSregistration=[[NSString alloc] initWithData:[handle readDataToEndOfFile] encoding:NSASCIIStringEncoding];

[resultCodeFromDynDNSregistration retain];
[pipe release];
[curltask release];

return resultCodeFromDynDNSregistration;

}
@end
