//
//  HDDoh.m
//  Doh
//
//  Created by Hugues Devaux (hdex@free.fr) on 18/06/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//
// Classe controlleur pour l'interface graphique

/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
*/

#import "HDDoh.h"
#import "DohTools.h"

@implementation HDDoh

- (IBAction)detectIP:(id)sender
{
[ovhProgressIndicator startAnimation:self];
[status setStringValue: NSLocalizedString(@"CheckIP", nil)];
DohTools *toolBox = [[DohTools alloc] init];
NSLog(@"OVH@Home : IP Detection started");

// Debug code to simulate IP Change[[NSUserDefaults standardUserDefaults] setValue:@"123.345.567.789" forKey:@"ipValue"];
// Set IP through bindings
[[NSUserDefaults standardUserDefaults] setValue:[toolBox webIpDetection:[detectedIP stringValue]] forKey:@"ipValue"];

if ([toolBox getNeedRegistration])  
		{
			if (![[username stringValue] isEqualToString:@""])
				{
					[status setStringValue: NSLocalizedString(@"IPOKRegNeeded", nil)];
					[self updateNow:self];
				}
			else {
			 [status setStringValue: NSLocalizedString(@"IPOKInfoNeeded", nil)];

				}

		}
	else {
			if ([[detectedIP stringValue] isEqualToString:NSLocalizedString(@"Unknown", nil)]) 
				{
				[status setStringValue: NSLocalizedString(@"IPUnknown", nil)];
				}
			else {
				[status setStringValue: NSLocalizedString(@"IPUnchanged", nil)];
				}
		}

[ovhProgressIndicator stopAnimation:self];

// Create delay to auto-check IP change
[[self class] cancelPreviousPerformRequestsWithTarget: self];
[self performSelector: @selector(detectIPTimer:) withObject: sender afterDelay: 350];

[toolBox release];
}

- (IBAction)updateNow:(id)sender
{
[status setStringValue: NSLocalizedString(@"DomUpdate", nil)];

DohTools *toolBox = [[DohTools alloc] init];

[status setStringValue: (@"%@",[toolBox dyndnsRegistration:[username stringValue] :[password stringValue] :[domain stringValue] :[detectedIP stringValue]])];

[[NSUserDefaults standardUserDefaults] setValue:[NSDate date] forKey:@"lastRegistration"];

// Create delay to auto-check IP change
[[self class] cancelPreviousPerformRequestsWithTarget: self];
[self performSelector: @selector(detectIPTimer:) withObject: sender afterDelay: 350];

[toolBox release];
}

- (IBAction)donate:(id)sender
{
[[NSWorkspace sharedWorkspace] openURL:[NSURL URLWithString: NSLocalizedString(@"PaypalLink", nil)]];
}

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification;
{

  [self detectIP:self];
}

+ (void)setupDefaults
{
    NSString *userDefaultsValuesPath;
    NSDictionary *userDefaultsValuesDict;
    NSDictionary *initialValuesDict;
       
    // load the default values for the user defaults
    userDefaultsValuesPath=[[NSBundle mainBundle] pathForResource:@"UserDefaults" 
                               ofType:@"plist"];
    userDefaultsValuesDict=[NSDictionary dictionaryWithContentsOfFile:userDefaultsValuesPath];
    
    // set them in the standard user defaults
    [[NSUserDefaults standardUserDefaults] registerDefaults:userDefaultsValuesDict];
    
    // Set the initial values in the shared user defaults controller 
    [[NSUserDefaultsController sharedUserDefaultsController] setInitialValues:initialValuesDict];
}

- (void)detectIPTimer:(id)sender
{
    [status setStringValue: NSLocalizedString(@"StartIPDetect", nil)];
	[self detectIP:self];
} 

-(BOOL) applicationShouldTerminateAfterLastWindowClosed:(NSApplication *)theApplication
{

    return YES;
}
@end
